ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/App-Staticperl/staticperl.sh
(Generate patch)

Comparing App-Staticperl/staticperl.sh (file contents):
Revision 1.17 by root, Sun Dec 12 00:38:36 2010 UTC vs.
Revision 1.33 by root, Thu Feb 24 07:10:03 2011 UTC

6STATICPERL=~/.staticperl 6STATICPERL=~/.staticperl
7CPAN=http://mirror.netcologne.de/cpan # which mirror to use 7CPAN=http://mirror.netcologne.de/cpan # which mirror to use
8EMAIL="read the documentation <rtfm@example.org>" 8EMAIL="read the documentation <rtfm@example.org>"
9 9
10# perl build variables 10# perl build variables
11MAKE=make
11PERL_VERSION=5.12.2 # 5.8.9 is also a good choice 12PERL_VERSION=5.12.3 # 5.8.9 is also a good choice
13PERL_CC=cc
12PERL_CONFIGURE="" # additional Configure arguments 14PERL_CONFIGURE="" # additional Configure arguments
13PERL_CPPFLAGS="-DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=65536 -D_GNU_SOURCE -DNDEBUG -USITELIB_EXP -USITEARCHEXP -UARCHLIB_EXP" 15PERL_CCFLAGS="-g -DPERL_DISABLE_PMC -DPERL_ARENA_SIZE=16376 -DNO_PERL_MALLOC_ENV -D_GNU_SOURCE -DNDEBUG"
14PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math" 16PERL_OPTIMIZE="-Os -ffunction-sections -fdata-sections -finline-limit=8 -ffast-math"
15 17
16ARCH="$(uname -m)" 18ARCH="$(uname -m)"
17 19
18case "$ARCH" in 20case "$ARCH" in
31# --allow-multiple-definition exists to work around uclibc's pthread static linking bug 33# --allow-multiple-definition exists to work around uclibc's pthread static linking bug
32PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition" 34PERL_LDFLAGS="-Wl,--no-gc-sections -Wl,--allow-multiple-definition"
33PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself 35PERL_LIBS="-lm -lcrypt" # perl loves to add lotsa crap itself
34 36
35# some configuration options for modules 37# some configuration options for modules
36export PERL_MM_USE_DEFAULT=1 38PERL_MM_USE_DEFAULT=1
37#export CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow 39#CORO_INTERFACE=p # needed without nptl on x86, due to bugs in linuxthreads - very slow
38export EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0' 40EV_EXTRA_DEFS='-DEV_FEATURES=4+8+16+64 -DEV_USE_SELECT=0 -DEV_USE_POLL=1 -DEV_USE_EPOLL=1 -DEV_NO_LOOPS -DEV_COMPAT3=0'
41export PERL_MM_USE_DEFAULT CORO_INTERFACE EV_EXTRA_DEFS
39 42
40# which extra modules to install by default from CPAN that are 43# which extra modules to install by default from CPAN that are
41# required by mkbundle 44# required by mkbundle
42STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage" 45STATICPERL_MODULES="common::sense Pod::Strip PPI::XS Pod::Usage"
43 46
64 67
65MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}" 68MKBUNDLE="${MKBUNDLE:=$STATICPERL/mkbundle}"
66PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed 69PERL_PREFIX="${PERL_PREFIX:=$STATICPERL/perl}" # where the perl gets installed
67 70
68unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG 71unset PERL5OPT PERL5LIB PERLLIB PERL_UNICODE PERLIO_DEBUG
69export LC_ALL=C # just to be on the safe side 72LC_ALL=C; export LC_ALL # just to be on the safe side
70 73
71# set version in a way that Makefile.PL can extract 74# set version in a way that Makefile.PL can extract
72VERSION=VERSION; eval \ 75VERSION=VERSION; eval \
73$VERSION=0.911 76$VERSION="1.1"
74 77
75BZ2=bz2 78BZ2=bz2
76BZIP2=bzip2 79BZIP2=bzip2
77 80
78fatal() { 81fatal() {
124 127
125clean() { 128clean() {
126 rm -rf "$STATICPERL/src/perl-$PERL_VERSION" 129 rm -rf "$STATICPERL/src/perl-$PERL_VERSION"
127} 130}
128 131
132realclean() {
133 rm -f "$PERL_PREFIX/staticstamp.postinstall"
134 rm -f "$PERL_PREFIX/staticstamp.install"
135 rm -f "$STATICPERL/src/perl-"*"/staticstamp.configure"
136}
137
129fetch() { 138fetch() {
130 rcd "$STATICPERL" 139 rcd "$STATICPERL"
131 140
132 mkdir -p src 141 mkdir -p src
133 rcd src 142 rcd src
143perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL 152perl-$PERL_VERSION.tar.$BZ2 in $STATICPERL
144trying $URL 153trying $URL
145EOF 154EOF
146 155
147 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side 156 rm -f perl-$PERL_VERSION.tar.$BZ2~ # just to be on the safe side
157 curl -f >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
148 wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \ 158 || wget -O perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
149 || curl >perl-$PERL_VERSION.tar.$BZ2~ "$URL" \
150 || fatal "$URL: unable to download" 159 || fatal "$URL: unable to download"
160 rm -f perl-$PERL_VERSION.tar.$BZ2
151 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2 161 mv perl-$PERL_VERSION.tar.$BZ2~ perl-$PERL_VERSION.tar.$BZ2
152 fi 162 fi
153 163
154 verblock <<EOF 164 verblock <<EOF
155unpacking perl 165unpacking perl
156EOF 166EOF
157 167
158 mkdir -p unpack 168 mkdir -p unpack
169 rm -rf unpack/perl-$PERL_VERSION
159 $BZIP2 -d <perl-$PERL_VERSION.tar.bz2 | tar xfC - unpack \ 170 $BZIP2 -d <perl-$PERL_VERSION.tar.$BZ2 | tar xfC - unpack \
160 || fatal "perl-$PERL_VERSION.tar.bz2: error during unpacking" 171 || fatal "perl-$PERL_VERSION.tar.$BZ2: error during unpacking"
161 chmod -R u+w unpack/perl-$PERL_VERSION 172 chmod -R u+w unpack/perl-$PERL_VERSION
162 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION 173 mv unpack/perl-$PERL_VERSION perl-$PERL_VERSION
163 rmdir -p unpack 174 rmdir -p unpack
164 fi 175 fi
165} 176}
166 177
167# similar to GNU-sed -i or perl -pi 178# similar to GNU-sed -i or perl -pi
168sedreplace() { 179sedreplace() {
169 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed" 180 sed -e "$1" <"$2" > "$2~" || fatal "error while running sed"
181 rm -f "$2"
170 mv "$2~" "$2" 182 mv "$2~" "$2"
183}
184
185configure_failure() {
186 cat <<EOF
187
188
189***
190*** Configure failed - see above for the exact error message(s).
191***
192*** Most commonly, this is because the default PERL_CCFLAGS or PERL_OPTIMIZE
193*** flags are not supported by your compiler. Less often, this is because
194*** PERL_LIBS either contains a library not available on your system (such as
195*** -lcrypt), or because it lacks a required library (e.g. -lsocket or -lnsl).
196***
197*** You can provide your own flags by creating a ~/.staticperlrc file with
198*** variable assignments. For example (these are the actual values used):
199***
200
201PERL_CC="$PERL_CC"
202PERL_CCFLAGS="$PERL_CCFLAGS"
203PERL_OPTIMIZE="$PERL_OPTIMIZE"
204PERL_LDFLAGS="$PERL_LDFLAGS"
205PERL_LIBS="$PERL_LIBS"
206
207EOF
208 exit 1
171} 209}
172 210
173configure() { 211configure() {
174 fetch 212 fetch
175 213
181configuring $STATICPERL/src/perl-$PERL_VERSION 219configuring $STATICPERL/src/perl-$PERL_VERSION
182EOF 220EOF
183 221
184 rm -f "$PERL_PREFIX/staticstamp.install" 222 rm -f "$PERL_PREFIX/staticstamp.install"
185 223
186 make distclean >/dev/null 2>&1 224 "$MAKE" distclean >/dev/null 2>&1
187 225
226 sedreplace '/^#define SITELIB/d' config_h.SH
227
188 # I hate them 228 # I hate them for this
189 grep -q -- -fstack-protector Configure && \ 229 grep -q -- -fstack-protector Configure && \
190 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure 230 sedreplace 's/-fstack-protector/-fno-stack-protector/g' Configure
191 231
192 preconfigure 232 preconfigure
193 233
197 -Dusemymalloc=n \ 237 -Dusemymalloc=n \
198 -Uusedl \ 238 -Uusedl \
199 -Uusethreads \ 239 -Uusethreads \
200 -Uuseithreads \ 240 -Uuseithreads \
201 -Uusemultiplicity \ 241 -Uusemultiplicity \
202 -Duseperlio \
203 -Uusesfio \ 242 -Uusesfio \
204 -Uuseshrplib \ 243 -Uuseshrplib \
244 -Uinstallusrbinperl \
205 -Dcppflags="$PERL_CPPFLAGS" \ 245 -A ccflags=" $PERL_CCFLAGS" \
206 -Dccflags="-g2 -fno-strict-aliasing" \ 246 -Dcc="$PERL_CC" \
207 -Doptimize="$PERL_OPTIMIZE" \ 247 -Doptimize="$PERL_OPTIMIZE" \
208 -Dldflags="$PERL_LDFLAGS" \ 248 -Dldflags="$PERL_LDFLAGS" \
209 -Dlibs="$PERL_LIBS" \ 249 -Dlibs="$PERL_LIBS" \
210 -Dprefix="$PERL_PREFIX" \ 250 -Dprefix="$PERL_PREFIX" \
211 -Dbin="$PERL_PREFIX/bin" \ 251 -Dbin="$PERL_PREFIX/bin" \
212 -Dprivlib="$PERL_PREFIX/lib" \ 252 -Dprivlib="$PERL_PREFIX/lib" \
213 -Darchlib="$PERL_PREFIX/lib" \ 253 -Darchlib="$PERL_PREFIX/lib" \
214 -Uusevendorprefix \ 254 -Uusevendorprefix \
215 -Dsitelib="$PERL_PREFIX/lib" \ 255 -Dsitelib="$PERL_PREFIX/lib" \
216 -Dsitearch="$PERL_PREFIX/lib" \ 256 -Dsitearch="$PERL_PREFIX/lib" \
217 -Usitelibexp \
218 -Uman1dir \ 257 -Uman1dir \
219 -Uman3dir \ 258 -Uman3dir \
220 -Usiteman1dir \ 259 -Usiteman1dir \
221 -Usiteman3dir \ 260 -Usiteman3dir \
222 -Dpager=/usr/bin/less \ 261 -Dpager=/usr/bin/less \
223 -Demail="$EMAIL" \ 262 -Demail="$EMAIL" \
224 -Dcf_email="$EMAIL" \ 263 -Dcf_email="$EMAIL" \
225 -Dcf_by="$EMAIL" \ 264 -Dcf_by="$EMAIL" \
226 $PERL_CONFIGURE \ 265 $PERL_CONFIGURE \
266 -Duseperlio \
227 -dE || fatal "Configure failed" 267 -dE || configure_failure
228 268
229 sedreplace ' 269 sedreplace '
230 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g 270 s/-Wl,--no-gc-sections/-Wl,--gc-sections/g
231 s/ *-fno-stack-protector */ /g 271 s/ *-fno-stack-protector */ /g
232 ' config.sh 272 ' config.sh
247building $STATICPERL/src/perl-$PERL_VERSION 287building $STATICPERL/src/perl-$PERL_VERSION
248EOF 288EOF
249 289
250 rm -f "$PERL_PREFIX/staticstamp.install" 290 rm -f "$PERL_PREFIX/staticstamp.install"
251 291
252 make || fatal "make: error while building perl" 292 "$MAKE" || fatal "make: error while building perl"
253 293
254 postbuild || fatal "postbuild hook failed" 294 postbuild || fatal "postbuild hook failed"
255} 295}
256 296
257install() { 297install() {
267 ln -sf "perl/lib/" "$STATICPERL/lib" 307 ln -sf "perl/lib/" "$STATICPERL/lib"
268 308
269 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten 309 ln -sf "$PERL_PREFIX" "$STATICPERL/perl" # might get overwritten
270 rm -rf "$PERL_PREFIX" # by this rm -rf 310 rm -rf "$PERL_PREFIX" # by this rm -rf
271 311
272 make install || fatal "make install: error while installing" 312 "$MAKE" install || fatal "make install: error while installing"
273 313
274 rcd "$PERL_PREFIX" 314 rcd "$PERL_PREFIX"
275 315
276 # create a "make install" replacement for CPAN 316 # create a "make install" replacement for CPAN
277 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF 317 cat >"$PERL_PREFIX"/bin/cpan-make-install <<EOF
278make || exit 318"$MAKE" || exit
279 319
280if find blib/arch/auto -type f | grep -q -v .exists; then 320if find blib/arch/auto -type f | grep -q -v .exists; then
281 echo Probably an XS module, rebuilding perl 321 echo Probably an XS module, rebuilding perl
282 if make perl; then 322 if "$MAKE" perl; then
283 mv perl "$PERL_PREFIX"/bin/perl 323 mv perl "$PERL_PREFIX"/bin/perl~ \
324 && rm -f "$PERL_PREFIX"/bin/perl \
325 && mv "$PERL_PREFIX"/bin/perl~ "$PERL_PREFIX"/bin/perl
284 make -f Makefile.aperl map_clean 326 "$MAKE" -f Makefile.aperl map_clean
285 else 327 else
286 make -f Makefile.aperl map_clean 328 "$MAKE" -f Makefile.aperl map_clean
287 exit 1 329 exit 1
288 fi 330 fi
289fi 331fi
290 332
291make install UNINST=1 333"$MAKE" install UNINST=1
292EOF 334EOF
293 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install 335 chmod 755 "$PERL_PREFIX"/bin/cpan-make-install
294 336
295 # trick CPAN into avoiding ~/.cpan completely 337 # trick CPAN into avoiding ~/.cpan completely
296 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm" 338 echo 1 >"$PERL_PREFIX/lib/CPAN/MyConfig.pm"
356 for mod in "$@"; do 398 for mod in "$@"; do
357 echo 399 echo
358 echo $mod 400 echo $mod
359 ( 401 (
360 rcd $mod 402 rcd $mod
361 make -f Makefile.aperl map_clean >/dev/null 2>&1 403 "$MAKE" -f Makefile.aperl map_clean >/dev/null 2>&1
362 make distclean >/dev/null 2>&1 404 "$MAKE" distclean >/dev/null 2>&1
363 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL" 405 "$PERL_PREFIX"/bin/perl Makefile.PL || fatal "$mod: error running Makefile.PL"
364 make || fatal "$mod: error building module" 406 "$MAKE" || fatal "$mod: error building module"
365 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module" 407 "$PERL_PREFIX"/bin/cpan-make-install || fatal "$mod: error installing module"
366 make distclean >/dev/null 2>&1 408 "$MAKE" distclean >/dev/null 2>&1
367 exit 0 409 exit 0
368 ) || exit $? 410 ) || exit $?
369 done 411 done
370} 412}
371 413
419 command="${1#--}"; shift 461 command="${1#--}"; shift
420 case "$command" in 462 case "$command" in
421 version ) 463 version )
422 echo "staticperl version $VERSION" 464 echo "staticperl version $VERSION"
423 ;; 465 ;;
424 fetch | configure | build | install | clean | distclean) 466 fetch | configure | build | install | clean | realclean | distclean)
425 ( "$command" ) 467 ( "$command" ) || exit
426 ;; 468 ;;
427 instsrc ) 469 instsrc )
428 ( instsrc "$@" ) 470 ( instsrc "$@" ) || exit
429 exit 471 exit
430 ;; 472 ;;
431 instcpan ) 473 instcpan )
432 ( instcpan "$@" ) 474 ( instcpan "$@" ) || exit
433 exit 475 exit
434 ;; 476 ;;
435 cpan ) 477 cpan )
436 ( install ) 478 ( install ) || exit
437 "$PERL_PREFIX/bin/cpan" "$@" 479 "$PERL_PREFIX/bin/cpan" "$@"
438 exit 480 exit
439 ;; 481 ;;
440 mkbundle ) 482 mkbundle )
441 ( install ) 483 ( install ) || exit
442 bundle "$@" 484 bundle "$@"
443 exit 485 exit
444 ;; 486 ;;
445 mkperl ) 487 mkperl )
446 ( install ) 488 ( install ) || exit
447 bundle --perl "$@" 489 bundle --perl "$@"
448 exit 490 exit
449 ;; 491 ;;
450 mkapp ) 492 mkapp )
451 ( install ) 493 ( install ) || exit
452 bundle --app "$@" 494 bundle --app "$@"
453 exit 495 exit
454 ;; 496 ;;
455 help ) 497 help )
456 podusage 2 498 podusage 2

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines